/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012 by Meika Sugimoto
 *  Copyright (C) 2015 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*
 * ^[Qbgˑ@AZuiCQ-FRM-FM3pj
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)			(val)
#define ULONG_C(val)		(val)
#include "kernel_impl.h"
#include "cq_frm_fm3.h"

/*
 * ჌x̃^[Qbgˑ̏
 *
 * ̑OɌĂяo
 */

	.globl	hardware_init_hook

	.text
	.align 2
	.syntax unified
	.code 16
	.thumb
	.type	hardware_init_hook, function
hardware_init_hook:
	/* eoXNbÑvXP[ݒ */
	ldr	r0 , =#BSC_PSR					/* x[XNbN(1) */
	mov	r1 , #BSC_CLK_DIV_1
	str	r1 , [r0]
	
	ldr	r0 , =#APBC0_PSR				/* APB0(8) */
	mov	r1 , #APB_CLK_DIV_8
	str	r1 , [r0]
	
	ldr	r0 , =#APBC1_PSR				/* APB1(8) */
	mov	r1 , #(APB_CLK_DIV_8 | APBC_EN | APBC_RESET)
	str	r1 , [r0]
	mov	r1 , #(APB_CLK_DIV_8 | APBC_EN)
	str	r1 , [r0]
	
	ldr	r0 , =#APBC2_PSR				/* APB2(8) */
	mov	r1 , #(APB_CLK_DIV_8 | APBC_EN | APBC_RESET)
	str	r1 , [r0]
	mov	r1 , #(APB_CLK_DIV_8 | APBC_EN)
	str	r1 , [r0]
	
	ldr	r0 , =#INT_CLR		/* INT_CLR̃NA */
	mov	r1 , #(INT_CLL_MCS | INT_CLL_SCS | INT_CLL_PCS | INT_CLL_FCS)
	str	r1 , [r0]
	
	/* CNbNM҂݂̐ݒ */
	ldr	r0 , =#CSW_PSR
	mov	r1 , #PSW_TMR_MOWT_CONF12
	str	r1 , [r0]
	
	/* CNbN͈҂ݗL */
	ldr	r0 , =#INT_ENR
	mov	r1 , #INT_CLL_MCS
	str	r1 , [r0]
	
	/* CNbNN */
	ldr	r0 , =#SCM_CTL
	ldr	r1 , [r0]
	and r1 , #SCM_CTL_MOSCE
	str	r1 , [r0]
	
	/* CNbN҂ */
	ldr	r0 , =#SCM_STR
  wait_main_clock_stable:
	ldr	r1 , [r0]
	orr	r1 , #SCM_STR_MORDY
	beq wait_main_clock_stable
	
	/* PLL̓NbNƔM҂݂̐ݒ */
	ldr	r0 , =#PSW_TMR
	mov	r1 , #(PSW_TMR_PINC_MO | PSW_TMR_POWT_CONF7)	/* ҂Ԃ͍ől */
	str	r1 , [r0]
	
	/* PLL͈҂ݗL */
	ldr	r0 , =#INT_ENR
	mov	r1 , #INT_CLL_PCS
	str	r1 , [r0]
	
	/* PLL̕ݒ */
	ldr	r0 , =#PLL_CTL1		/* PLLK , PLLM */
	mov	r1 , #(PLL_CTL1_PLLK(PLLK_VALUE) | PLL_CTL1_PLLM(PLLM_VALUE))
	str	r1 , [r0]
	ldr	r0 , =#PLL_CTL2		/* PLLN */
	mov	r1 , #PLL_CTL2_PLLN(PLLN_VALUE)
	str	r1 , [r0]
	
	/* PLLN */
	ldr	r0 , =#SCM_CTL
	ldr	r1 , [r0]
	orr r1 , #SCM_CTL_PLLE
	str	r1 , [r0]
	
	/* PLL҂ */
	ldr	r0 , =#SCM_STR		/* APB2(8) */
  wait_pll_stable:
	ldr	r1 , [r0]
	and	r1 , #SCM_STR_PLRDY
	beq wait_pll_stable

	/* }X^NbN؂ւ */
	ldr	r0 , =#SCM_CTL
	ldr	r1 , [r0]
	and r1 , #~SCM_CTL_RCS_MASK
	orr r1 , #SCM_CTL_RCS_PLLCLK
	str	r1 , [r0]
	
	isb
	
	/* g[XNbN̐ݒ */
	ldr	r0 , =#TTC_PSR				/* TTC(8) */
	mov	r1 , #(APB_CLK_DIV_8)
	str	r1 , [r0]
	
	/* g[X|[g̐ݒ */
	ldr	r0 , =#PFR0
	ldr	r1 , [r0]
	orr r1 , #(0x01F << 5)
	str	r1 , [r0]
	
	ldr	r0 , =#EPFR0
	ldr	r1 , [r0]
	orr r1 , #(0x03 << 24)
	str	r1 , [r0]
	
	bx	lr

